## ros-indigo-canopen-master 0.6.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(canopen_master)

find_package(catkin REQUIRED
  COMPONENTS
    class_loader
    socketcan_interface
)

find_package(Boost REQUIRED
  COMPONENTS
    atomic
    chrono
    thread
)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    canopen_master
  CATKIN_DEPENDS
    socketcan_interface
  DEPENDS
    Boost
)
include_directories(include ${catkin_INCLUDE_DIRS})

add_library(canopen_master
  src/emcy.cpp
  src/master.cpp
  src/node.cpp
  src/objdict.cpp
  src/pdo.cpp
  src/sdo.cpp
)
target_link_libraries(canopen_master
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
)

add_library(canopen_master_plugin
  src/master_plugin.cpp
)

target_link_libraries(canopen_master_plugin
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
  canopen_master
)

# canopen_bcm_sync
add_executable(canopen_bcm_sync
  src/bcm_sync.cpp
)
target_link_libraries(canopen_bcm_sync
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
)

install(
  TARGETS
    canopen_bcm_sync
    canopen_master
    canopen_master_plugin
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(
  DIRECTORY
    include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

install(
  FILES
    master_plugin.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

if(CATKIN_ENABLE_TESTING)
  catkin_add_gtest(${PROJECT_NAME}-test_parser
    test/test_parser.cpp
  )
  target_link_libraries(${PROJECT_NAME}-test_parser
    canopen_master
  )
endif()

=== debian/changelog ===
ros-indigo-canopen-master (0.6.9-0trusty) trusty; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 22 May 2018 22:00:00 -0000

ros-indigo-canopen-master (0.6.8-0trusty) trusty; urgency=high

  * added EMCYHandler::resetErrors
  * added VectorHelper::callFunc
    generalized call templates
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 17 Jul 2017 22:00:00 -0000

ros-indigo-canopen-master (0.6.7-0trusty) trusty; urgency=high

  * fix: handle EMCY as error, not as warning
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 27 Mar 2017 22:00:00 -0000

ros-indigo-canopen-master (0.6.6-0trusty) trusty; urgency=high

  * refactored EMCY handling into separate layer
  * print EMCY to stdout
  * send node start on recover
    needed for external sync to work properly
  * pass halt on error unconditionally
  * added canopen_bcm_sync
  * added object access services
  * implemented ObjectStorage::getStringReader
  * implemented ExternalMaster
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 17 Mar 2017 23:00:00 -0000

ros-indigo-canopen-master (0.6.5-0trusty) trusty; urgency=high

  * Merge pull request #179 <https://github.com/ipa-mdl/ros_canopen/issues/179> from ipa-mdl/mixed_case_access
    support mixed-case access strings in EDS
  * decouple listener initialization from 1003 binding
  * introduced THROW_WITH_KEY and ObjectDict::key_info
  * added access type tests
  * convert access string to lowercase
  * Do not remove shared memory automatically
  * hardened code with the help of cppcheck
  * throw verbose exception if AccessType is missing (#64 <https://github.com/ipa-mdl/ros_canopen/issues/64>)
  * styled and sorted CMakeLists.txt
    * removed boilerplate comments
    * indention
    * reviewed exported dependencies
  * styled and sorted package.xml
  * canopen_master needs to depend on rosunit for gtest
  * update package URLs
  * fixed typo
  * do not reset PDO COB-ID if it is not writable
  * Do not recurse into sub-objects, handle them as simple data
  * strip string before searching for $NODEID
  * added NodeID/hex parser test
  * do full recover if if driver is not ready
  * wait for driver to be shutdown in run()
  * limit SDO reader to size of 1
  * do not send abort twice
  * removed unnecessary sleep (added for tests only)
  * catch all std exceptions in layer handlers
  * migrated SDOClient to BufferedReader
  * getter for LayerState
  * fixed lost wake-up condition, unified SDO accessors
  * minor NMT improvements
  * removed cond from PDOMapper, it does not wait on empty buffer anymore
  * Simple master counts nodes as well
  * throw exception on read from empty buffer
  * proper initialisation of PDO data from SDOs
  * change sync subscription only on change
  * shutdown and restart CAN layer on recover
  * canopen::Exception is now based on std::runtime_error
  * Merge pull request #109 <https://github.com/ipa-mdl/ros_canopen/issues/109> from ipa-mdl/shutdown-crashes
    Fix for pluginlib-related crashes on shutdown
  * stop after heartbeat was disabled, do not wait for state switch
  * added virtual destructor to SyncCounter
  * Use getHeartbeatInterval()
  * minor shutdown improvements
  * removed unstable StateWaiter::wait_for
  * Revert change to handleShutdown
  * Heartbeat interval is uint16, not double
  * Added validity check to heartbeat_ (Some devices do not support heartbeat)
  * Contributors: Florian Weisshardt, Mathias Lüdtke, Michael Stoll

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 09 Dec 2016 23:00:00 -0000

ros-indigo-canopen-master (0.6.4-0trusty) trusty; urgency=high

  * added missing include, revised depends etc.

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 02 Jul 2015 22:00:00 -0000

ros-indigo-canopen-master (0.6.3-0trusty) trusty; urgency=high

  * added Settings class
  * added SimpleMaster
  * remove boost::posix_time::milliseconds from SyncProperties
  * removed support for silence_us since bus timing cannot be guaranteed
  * properly handle cases where def_val == init_val
  * implemented plugin-based Master allocators, defaults to LocalMaster
  * moved master/synclayer base classes to canopen.h
  * added support for non-continuous PDO ranges
  * added has() check to object dictionary interface
  * improved ObjectStorage entry interface
  * verbose out_of_range exception
  * improved timer: duration cast, autostart flag
  * reset sync waiter number after timeout
  * verbose timeout exception
  * little fix im EMCY diagnostics
  * string instead of mulit-char constant
  * Merge branch 'hwi_switch' into muparser
  * added std::string converters to ObjectDict::Key
  * do not warn on profile-only errors
  * added get_abs_time without parameter
  * link against boost_atomic for platforms with lock-based implementation
  * reset sent Reset and Reset_Com, c&p bug
  * stop heartbeat after node shutdown
  * protect reads of LayerState
  * protect layers in VectorHelper
  * protect buffer data
  * set error only if generic error bit is set, otherwise just warn about it
  * Fixes https://github.com/ipa320/ros_canopen/issues/81
  * Update emcy.cpp
  * removed debug outputs
  * refactored Layer mechanisms
  * simplified init
  * simplified EMCY handling
  * improved hearbeat handling
  * do not stop master on slave timeout
  * improved pending handling in complex layers
  * added set_cached for object entries
  * removed IPCLayer sync listener, loopback is disabled per default
  * Merge branch 'dummy_interface' into indigo_dev
    Conflicts:
    canopen_master/src/objdict.cpp
  * added sync silence feature
  * Merge remote-tracking branch 'origin/fix32bit' into indigo_dev
  * require message strings for error indicators, added missing strings, added ROS logging in sync loop
  * fix ambiguous buffer access with 32bit compilers
  * pad octet strings if necessary


=== debian/control ===
Source: ros-indigo-canopen-master
Section: misc
Priority: extra
Maintainer: Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-indigo-catkin, ros-indigo-class-loader, ros-indigo-rosunit, ros-indigo-socketcan-interface
Homepage: http://wiki.ros.org/canopen_master
Standards-Version: 3.9.2

Package: ros-indigo-canopen-master
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-indigo-class-loader, ros-indigo-socketcan-interface
Description: CiA(r) CANopen 301 master implementation with support for interprocess master synchronisation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-canopen-master//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
